<template>
  <v-card width="450px" height="400px" class="pa-4">
    <v-row class="justify-center">
      <v-col
        align="left"
        class="flex-grow-0 text-no-wrap d-flex align-center pr-0"
      >
        <h3>{{ title }}</h3>
      </v-col>
      <v-col class="align-center d-flex align-end pl-0">
        <span class="period-value"> {{ period }}</span>
      </v-col>
      <v-col align="right">
        <SettingChart
          @delete:chart="onDeleteHandler"
          @edit:chart="onEditHandler"
          @duplicate:chart="onDuplicateHandler"
        />
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <Pie id="pie-chart" :data="data" :options="options" />
      </v-col>
    </v-row>
  </v-card>
</template>

<script>
import { Chart as ChartJS, ArcElement, Tooltip, Legend } from "chart.js";
import { Pie } from "vue-chartjs";
import SettingChart from "./SettingChart.vue";

ChartJS.register(ArcElement, Tooltip, Legend);

export default {
  name: "PieChart",
  emits: ["edit:chart", "delete:chart", "duplicate:chart"],
  props: {
    data: Object,
    options: Object,
    title: String,
    id: Number,
    period: String,
  },
  components: {
    Pie,
    SettingChart,
  },
  methods: {
    onDuplicateHandler() {
      this.$emit("duplicate:chart", this.id);
    },
    onEditHandler() {
      this.$emit("edit:chart", this.id);
    },
    onDeleteHandler() {
      this.$emit("delete:chart", this.id);
    },
  },
};
</script>

<style scoped>
.pie-chart {
  height: 300px !important;
}

.period-value {
  font-size: 12px;
  margin-left: 5px;
  color: #7f7c7c;
  margin-top: 4px;
}
</style>